@make(ais)
@aiInfo(topic=<Private Types are too private>,
number=[AI-00854/01],
classcode=[ST],
statuscode=[RE],
mainref=[07.04@\(00)],
date=[90-01-10])
@aiHeading()
@begin(history)
@begin(toplines)
@mainref()
!class study 89-12-11
!status received 89-12-11
@end(toplines)
@topic{!topic Private Types are too private}
@end(history)

@subheading[!summary 89-12-11]


@subheading[!question 89-12-11]


@subheading[!recommendation 89-12-11]


@subheading[!discussion 89-12-11]


@begin(appendix)
@subheading[!appendix @cbon()89-12-13]@cboff()
@begin(sectionGroup)
@mybar()

!section 07.04    (00)   Erhard Ploedereder     89-10-24            83-01319
!version 1983
!topic Private Types are too private
@end(sectionGroup)

!summary
There should be a way for "friendly packages" to gain access to the
information contained in the private part of a package.

!rationale
It is a recurring problem in the formulation of interface specifications
that some types are pervasive throughout the interfaces offered. These
types may have to be (limited) private to the user of the interfaces.
Yet, it can be exceedingly inconvenient to combine all interfaces whose
implementation requires knowledge of the internals of these types in a
single package to establish the necessary visibility into the internals
of the private type. Rather, a grouping by functional area or capabilities
is desirable. However, such capability packages cannot be implemented
cleanly, due to the obvious visibility problems. Furthermore, many of the
employed implementation schemes falter when these private types are needed
as actual parameters to generic units required for the implementation of
the types themselves and visible to the users of the interfaces.

Examples of large interfaces that had to contend with these problems are
MIL-STD-1838(a), PCTE Ada Binding, X-Window binding and others.

Current work-arounds range from unchecked_conversion techniques to hidden
type implementation packages, assumed to be known only to the implementors
of the interfaces but not the user of the interfaces. The former is
obviously fraught with danger; the latter quickly becomes unwieldy and
requires numerous type conversions. Neither addresses the mentioned issue of
generic instantiations with such private types cleanly.

A possible and rather simple solution would be to extend context clauses
of packages such that "friendly access" to the private part of an imported
unit can be established, e.g.,

with foo;  -- normal non-private visibility
with private bar; -- grants visibility to private part of bar as well
package friend is ....

@cbon()@begin(sectionGroup)
@mybar()

!section 07.04    (00) P. Brashear  89-12-13                         83-01347
!version 1983
!topic Private Types are too private
@end(sectionGroup)
!reference AI-00854/00

The example proposed by E. Ploedereder as a way of granting "friendly"
packages access to the private part of another package would open the
private part of the package to any casual user of the package.  It
seems that the devoted "lowest-level-possible" programmer would often
take advantage of this invitation to defeat the private mechanism,
an make full use of implementation details in the name of efficiency
(and hang the notion of maintainability!).

Any solution to the stated problem should be under control of the
programmer of the original package, not of package users.@cboff()

@end(appendix)
